create or replace 
PROCEDURE ETL_INDSUPORTE(P_DTINI  IN DATE,
                                           P_DTFINA IN DATE)
IS

 V_DTINI          DATE;
 V_DTFINA         DATE;

 V_MES            VARCHAR2(2);
 V_ANO            VARCHAR2(4);
 V_BIM            VARCHAR2(6);
 V_TRI            VARCHAR2(6);
 V_SEM            VARCHAR2(6);
 V_NRTAREFA       VARCHAR2(10);
 V_SITATEND       VARCHAR2(20);
 V_SITUACAO       VARCHAR2(20);

 V_QTATEND        NUMBER;
 V_COUNT          INTEGER := 0;

 V_QTTOTATIV      FLOAT;
 V_QTTOTATEND     FLOAT;
 V_TOTALPORC      FLOAT;
 V_TMPRESPATEND   FLOAT := 0;
 V_TMPCONCATEND   FLOAT := 0;

 /*CONSTANTES*/
 CON_CONCLUIDO     VARCHAR2(9)  := 'Concludo';
 CON_ANDAMENTO     VARCHAR2(12) := 'Em Andamento';
 CON_PENDENTE      VARCHAR2(08) := 'Pendente';
 CON_CANCELADO     VARCHAR2(09) := 'Cancelada';
 CON_LIBERACAO     VARCHAR2(20) := 'Aguardando Liberao';

BEGIN

 V_DTINI := TO_DATE(TO_CHAR('01'||TO_CHAR(P_DTINI,'MM/YYYY')), 'DD/MM/YYYY');
 V_MES    :=   TO_CHAR(V_DTINI, 'MM');
 V_ANO    :=   TO_CHAR(V_DTINI, 'YYYY');

 DELETE FROM ETLATENDTEK
 WHERE (CDANOBI > V_ANO) OR
       (CDANOBI = V_ANO AND
        CDMESBI >= V_MES);
 COMMIT;

 DELETE FROM ETLCONATETEK
 WHERE (CDANOBI > V_ANO) OR
       (CDANOBI = V_ANO AND
        CDMESBI >= V_MES);
 COMMIT;

 WHILE(V_DTINI <= P_DTFINA) LOOP

      V_DTFINA :=   LAST_DAY(V_DTINI);
      V_MES    :=   TO_CHAR(V_DTINI, 'MM');
      V_ANO    :=   TO_CHAR(V_DTINI, 'YYYY');
      V_BIM    :=   TO_CHAR(TRUNC((V_MES - 1) / 2) + 1)||' Bim';
      V_TRI    :=   TO_CHAR(TRUNC((V_MES - 1) / 3) + 1)||' Tri';
      V_SEM    :=   TO_CHAR(TRUNC((V_MES - 1) / 6) + 1)||' Sem';


          SELECT
                NVL(COUNT(PL.NRPLATIVTARE),0)
           INTO
                V_QTTOTATIV
           FROM
                PLANATIVTARE PL, TAREFA TF, OPERADOR OP
          WHERE
                TRUNC(DTINCATIVTAR) BETWEEN V_DTINI AND V_DTFINA
            AND TF.NRTAREFA    = PL.NRTAREFA
            AND TF.IDORIGTARE  = '2'
            AND PL.CDOPERRESP  = OP.CDOPERADOR
            AND TF.CDFILIAL    = PL.CDFILIAL
            AND OP.CDSETOR     IN ('0121','0127','0143');


      FOR C_ETL IN
      (
       SELECT SUP.CDFILIAL,
              SUP.CDCLIENTE,
              SUP.IDSITTAREFA,
              SUP.CDOPERRESP,
              SUP.CDPRODCOMP,
              SUP.NRTAREFA,
              SUP.CDASSUNTO ,
              SUP.QTEVOL,
              SUP.TMPATIV,
              SUP.INTERLOCUTOR,
              SUP.TPATEND
         FROM
          (SELECT TF.CDFILIAL,
                TF.CDCLIENTE,
                TF.IDSITTAREFA,
                PL.CDOPERRESP,
                TF.CDPRODCOMP,
                PL.NRTAREFA,
                TF.CDASSUNTO ,
                COUNT(PL.NRPLATIVTARE) AS QTEVOL,
                0 TMPATIV,
                NVL(PL.NMINTATIVTAR, INTE.NMINTECLIE) AS INTERLOCUTOR,
                DECODE(SUBSTR(UPPER(CLI.NMFANTCLIE), 0, 7), 'TEKNISA','Interno','Externo') AS TPATEND
           FROM
                PLANATIVTARE PL, TAREFA TF, OPERADOR OP, CLIENTE CLI, INTECLIE INTE
          WHERE
                TRUNC(DTINCATIVTAR) BETWEEN V_DTINI AND V_DTFINA
            AND TF.NRTAREFA    = PL.NRTAREFA
            AND TF.IDORIGTARE  = '2'
            AND PL.CDOPERRESP  = OP.CDOPERADOR
            AND TF.CDFILIAL    = PL.CDFILIAL
            AND TF.CDCLIENTE   = CLI.CDCLIENTE
            AND OP.CDSETOR    IN ('0121','0127','0143')
            AND PL.CDCLIENTE   = INTE.CDCLIENTE  (+)
            AND PL.CDINTECLIE  = INTE.CDINTECLIE (+)
          GROUP BY
                PL.CDOPERRESP, TF.CDPRODCOMP, TF.CDASSUNTO,
                TF.CDFILIAL  , TF.CDCLIENTE , TF.NRTAREFA ,TF.IDSITTAREFA,
                NVL(PL.NMINTATIVTAR, INTE.NMINTECLIE)     , PL.NRTAREFA,
                DECODE(SUBSTR(UPPER(CLI.NMFANTCLIE), 0, 7), 'TEKNISA','Interno','Externo')

         UNION ALL

         SELECT TF.CDFILIAL,
                TF.CDCLIENTE,
                TF.IDSITTAREFA,
                PL.CDOPERRESP,
                TF.CDPRODCOMP,
                PL.NRTAREFA,
                TF.CDASSUNTO ,
                0 QTEVOL,
                SUM(AP.DTFAPATIVTAR - AP.DTIAPATIVTAR)*60 AS TMPATIV,
                NVL(PL.NMINTATIVTAR, INTE.NMINTECLIE) AS INTERLOCUTOR,
                DECODE(SUBSTR(UPPER(CLI.NMFANTCLIE), 0, 7), 'TEKNISA','Interno','Externo') AS TPATEND
           FROM
                PLANATIVTARE PL, TAREFA TF, OPERADOR OP, CLIENTE CLI, INTECLIE INTE, APROATIVTARE AP
          WHERE
                TRUNC(DTINCATIVTAR) BETWEEN V_DTINI AND V_DTFINA
            AND TF.NRTAREFA    = PL.NRTAREFA
            AND TF.IDORIGTARE  = '2'
            AND PL.CDOPERRESP  = OP.CDOPERADOR
            AND TF.CDFILIAL    = PL.CDFILIAL
            AND TF.CDCLIENTE   = CLI.CDCLIENTE
            AND OP.CDSETOR     IN ('0121','0127','0143')
            AND AP.CDFILIAL    = PL.CDFILIAL
            AND AP.NRTAREFA    = PL.NRTAREFA
            AND AP.NRPLATIVTARE= PL.NRPLATIVTARE
            AND AP.CDOPERADOR  = PL.CDOPERRESP
            AND PL.CDCLIENTE   = INTE.CDCLIENTE  (+)
            AND PL.CDINTECLIE  = INTE.CDINTECLIE (+)
          GROUP BY
                PL.CDOPERRESP, TF.CDPRODCOMP, TF.CDASSUNTO,
                TF.CDFILIAL  , TF.CDCLIENTE , TF.NRTAREFA ,TF.IDSITTAREFA,
                NVL(PL.NMINTATIVTAR, INTE.NMINTECLIE)     , PL.NRTAREFA,
                DECODE(SUBSTR(UPPER(CLI.NMFANTCLIE), 0, 7), 'TEKNISA','Interno','Externo'))SUP

      GROUP BY SUP.CDFILIAL,
               SUP.CDCLIENTE,
               SUP.IDSITTAREFA,
               SUP.CDOPERRESP,
               SUP.CDPRODCOMP,
               SUP.NRTAREFA,
               SUP.CDASSUNTO ,
               SUP.QTEVOL,
               SUP.TMPATIV,
               SUP.INTERLOCUTOR,
               SUP.TPATEND
      )
      LOOP


           IF C_ETL.IDSITTAREFA = 'C' THEN
               V_SITUACAO := CON_CONCLUIDO;
               ELSE IF C_ETL.IDSITTAREFA = 'A' THEN
                       V_SITUACAO := CON_ANDAMENTO;
                       ELSE IF C_ETL.IDSITTAREFA = 'X' THEN
                               V_SITUACAO := CON_CANCELADO;
                         ELSE IF C_ETL.IDSITTAREFA = 'P' THEN
                               V_SITUACAO := CON_PENDENTE;
                               ELSE IF C_ETL.IDSITTAREFA = 'l' THEN
                                       V_SITUACAO := CON_LIBERACAO;
                               END IF;
                         END IF;
                       END IF ;
               END IF;
            END IF;


             V_TOTALPORC := (C_ETL.QTEVOL*100)/V_QTTOTATIV;

             INSERT INTO ETLATENDTEK
                  (
                   CDFILIAL      , CDANOBI      , CDMESBI    ,
                   BIFATATEND    , TRFATATEND   , SEFATATEND ,
                   CDOPERADOR    , CDASSUNTO    , CDPRODUTO  ,
                   CDCLIENTE     , QTATEATEND   , DSSITUACAO ,
                   NMINTATIVTAR  , DSTPATEND    , VRPERCATEND,
                   QTTMPATEND    , NRTAREFA     , IDSTATUSATEND
                  )
            VALUES
                  (
                   C_ETL.CDFILIAL     , V_ANO           , V_MES              ,
                   V_BIM              , V_TRI           , V_SEM              ,
                   C_ETL.CDOPERRESP   , C_ETL.CDASSUNTO , C_ETL.CDPRODCOMP   ,
                   C_ETL.CDCLIENTE    , C_ETL.QTEVOL    , ('Com Atendimento'),
                   C_ETL.INTERLOCUTOR , C_ETL.TPATEND   , V_TOTALPORC        ,
                   C_ETL.TMPATIV      , C_ETL.NRTAREFA  , V_SITUACAO
                  );


            V_COUNT := V_COUNT + 1;
            IF V_COUNT >= 500 THEN
               COMMIT;
               V_COUNT := 0;
            END IF;

      END LOOP;

      COMMIT;

       FOR C_CLIENTE IN
       (
           SELECT CLI.CDCLIENTE
             FROM CLIENTE CLI
            WHERE CLI.CDCLIENTE NOT IN(
                                        SELECT DISTINCT CDCLIENTE
                                         FROM ETLATENDTEK
                                        WHERE CDANOBI = V_ANO
                                          AND CDMESBI = V_MES
                                      )

       )
       LOOP

            INSERT INTO ETLATENDTEK
                  (
                   CDANOBI     , CDMESBI    , BIFATATEND,
                   TRFATATEND  , SEFATATEND , CDCLIENTE,
                   QTATEATEND  , DSSITUACAO
                  )
            VALUES
                  (
                   V_ANO       , V_MES              , V_BIM               ,
                   V_TRI       , V_SEM              , C_CLIENTE.CDCLIENTE ,
                   (0)         , ('Sem Atendimento')
                  );

            V_COUNT := V_COUNT + 1;
            IF V_COUNT >= 500 THEN
               COMMIT;
               V_COUNT := 0;
            END IF;

       END LOOP;

       COMMIT;

          SELECT
                COUNT(DISTINCT TF.NRTAREFA)
           INTO
                V_QTTOTATEND
           FROM
                TAREFA TF, OPERADOR OP
          WHERE
                TRUNC(DTABERTAREFA) BETWEEN V_DTINI AND V_DTFINA

            AND TF.IDORIGTARE  = '2'
            AND TF.CDOPERRESP  = OP.CDOPERADOR
            AND OP.CDSETOR     IN ('0121','0127','0143');



      FOR C_ATEN IN
      (
        SELECT  TF.CDFILIAL  , TF.CDCLIENTE  ,
                TF.CDOPERRESP, TF.CDPRODCOMP ,
                TF.CDASSUNTO , TF.IDSITTAREFA,
                TF.NRTAREFA  , COUNT(DISTINCT TF.NRTAREFA) AS QTTAREFA,
                DECODE(SUBSTR(UPPER(CL.NMFANTCLIE), 0, 7), 'TEKNISA','Interno','Externo') AS TPATEND
           FROM
                TAREFA TF, OPERADOR OP, CLIENTE CL
          WHERE
                TRUNC(DTABERTAREFA) BETWEEN V_DTINI AND V_DTFINA

            AND TF.IDORIGTARE  = '2'
            AND TF.CDOPERRESP  = OP.CDOPERADOR
            AND OP.CDSETOR     IN ('0121','0127','0143')
            AND TF.CDCLIENTE   = CL.CDCLIENTE
          GROUP BY
                TF.CDFILIAL  , TF.CDCLIENTE, TF.IDSITTAREFA,
                TF.CDOPERRESP, TF.CDPRODCOMP, TF.CDASSUNTO, TF.NRTAREFA,
                DECODE(SUBSTR(UPPER(CL.NMFANTCLIE), 0, 7), 'TEKNISA','Interno','Externo')

      )
      LOOP
         IF C_ATEN.IDSITTAREFA = 'C' THEN
            V_TMPCONCATEND := TEMPO_CONC_ATEND(C_ATEN.CDFILIAL, C_ATEN.NRTAREFA);
            --V_TMPRESPATEND := TEMPO_RESP_ATEND(C_ATEN.CDFILIAL, C_ATEN.NRTAREFA);
         ELSE
            --V_TMPRESPATEND := TEMPO_RESP_ATEND(C_ATEN.CDFILIAL, C_ATEN.NRTAREFA);
            V_TMPCONCATEND := 0;
         END IF;

         BEGIN
          SELECT
                TEMPO_RESP_ATEND(TAR.CDFILIAL, TAR.NRTAREFA)
           INTO
                V_TMPRESPATEND
           FROM TAREFA TAR
          WHERE TAR.CDFILIAL = C_ATEN.CDFILIAL
            AND TAR.NRTAREFA = C_ATEN.NRTAREFA;
         END;

            IF C_ATEN.IDSITTAREFA = 'C' THEN
               V_SITATEND := CON_CONCLUIDO;
            ELSE IF C_ATEN.IDSITTAREFA = 'A' THEN
                    V_SITATEND := CON_ANDAMENTO;
                 ELSE IF C_ATEN.IDSITTAREFA = 'X' THEN
                         V_SITATEND := CON_CANCELADO;
                      ELSE IF C_ATEN.IDSITTAREFA = 'P' THEN
                              V_SITATEND := CON_PENDENTE;
                           ELSE IF C_ATEN.IDSITTAREFA = 'l' THEN
                                   V_SITATEND := CON_LIBERACAO;
                                END IF;
                           END IF;
                      END IF ;
                 END IF;
            END IF;

          V_TOTALPORC := (C_ATEN.QTTAREFA*100)/V_QTTOTATEND;

          INSERT INTO ETLCONATETEK
                  (
                   CDFILIAL    , CDANOBI      , CDMESBI     , BICONATEND  ,
                   TRCONATEND  , SECONATEND   , CDOPERADOR  , CDASSUNTO   ,
                   CDPRODUTO   , CDCLIENTE    , QTRESATEND  , QTTMPCONATEN,
                   QTTMPRESATEN, IDSTATUSATEND, NRTAREFA    , DSTPATEND   ,
                   VRPERCENTUAL
                  )
            VALUES
                  (
                   C_ATEN.CDFILIAL   , V_ANO            , V_MES             , V_BIM            ,
                   V_TRI             , V_SEM            , C_ATEN.CDOPERRESP , C_ATEN.CDASSUNTO ,
                   C_ATEN.CDPRODCOMP , C_ATEN.CDCLIENTE , C_ATEN.QTTAREFA   , V_TMPCONCATEND   ,
                   V_TMPRESPATEND    , V_SITATEND       , C_ATEN.NRTAREFA   , C_ATEN.TPATEND   ,
                   V_TOTALPORC
                  );

                  COMMIT;

      END LOOP;
      V_DTINI := ADD_MONTHS(V_DTINI,1);
 END LOOP;


END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ETL_INDSUPORTE','0.00.000'); END;
/
