#!/bin/bash

CURRENT_DATE=$(date +"%d/%m/%Y %H:%M:%S")
SCRIPT_FILE=$1
MODULE_NAME=$2
BASE_PATH='/var/www/equipe_teste/php7/tecfood/tecfood_devops'
BASE_PATH_LOG="/var/www/equipe_teste/php7"

dir_exists(){
	DIR=$1
	if [ -d $DIR ]; then
		return 0
	fi
	return 1
}
file_exists(){
	FILE=$1
	if [ -f $FILE ]; then
		return 0
	fi
	return 1
}

default_func(){
	return 2
}

print_log(){
	TYPE=$1
	VALUE=$2
	STATUS=$3
	MSG=""
	SEPARATOR="________________________________________________"
	#"------------------------------------------------"
		      
	HEADER="$SEPARATOR$SEPARATOR"
	FOOTER="$SEPARATOR"
	case $STATUS in
		0) MSG="EXISTS";;
		1) MSG="NOT_EXISTS";;
		2) MSG="INVALID_OPTION_TYPE";;
	esac
	echo -e "$HEADER\nDATE: $CURRENT_DATE\tFILE: $SCRIPT_FILE\n$MODULE_NAME\tSTATUS: $MSG $TYPE ($VALUE)" >> "$BASE_PATH_LOG/log.txt"

}

validate(){
	TYPE=$1 # DIR OR FILE
	VALUE=$2 # VALUE TO TEST
	case $TYPE in
		DIR)  dir_exists $VALUE ;;
		FILE) file_exists $VALUE ;;
		*)    default_func;;
	esac
	RESULT=$?
	case $RESULT in
		0) return 0;;
		1) return 1;;
		2) return 2;;
	esac
}

DIRECTORYS=(
		"backend" 
		"backend/vendor" 
		"backend/vendor/teknisa/libraries/config"
		"modules"
		"modules/login"
		"modules/acl"
		"modules/cmp"
		"modules/sup"
		"modules/opl"
		"modules/coz"
		"modules/dro"
		"modules/fai"
		"modules/gop"
		"modules/pla"
		"modules/mym"
		"modules/teknisa"
)
FILES=(
	"backend/vendor/teknisa/libraries/config/config.json" 
	"mobile/index.html"
	"mobile/assets/js/environment.js"
	"mobile/assets/js/app.js"
	"mobile/assets/js/libs.js"		
)
for file in ${FILES[@]}; 
do 
	validate FILE "$BASE_PATH/$file"
	print_log FILE "$BASE_PATH/$file" $?
done 
for dir in ${DIRECTORYS[@]}; 
do 
	validate DIR "$BASE_PATH/$dir"
	print_log DIR "$BASE_PATH/$dir" $?
done